$(function(){
	$(".yk_addBtns .save").removeClass('loadingCircle');
	//获取职级下拉框
	$.ajax({
		url:'/follow/rankLimit/do_all',
		type:'get',
		data:{},
		success:function(data){
			if(data.success) {
				var optionStr = '';
				for(var i=0; i<data.data.length; i++) {
					optionStr += `<option value="`+data.data[i].rank+`">`+data.data[i].rank+`</option>`
				}
				i=null;
				$("#rank").append(optionStr)
			}else {
				$("#rank").empty();
			}
		},
		error:function(status){
		}
	})

	//克隆'身份行'并添加到表单里
	function appendCloneDom(name,tag,orgid,userIdentity){
		var cloneIdentityDom = $(".indetityBox.hide").clone();
		cloneIdentityDom.find('input').attr('name','userIdentity'+tag);
		cloneIdentityDom.find('.userIdentitylabel').attr('orgid',orgid);
		cloneIdentityDom.removeClass('hide').addClass("show").find('.userIdentitylabel').text(name+'身份');
		if( userIdentity ){
			cloneIdentityDom.find('input').eq(1).prop('checked',true);
		}else{
			cloneIdentityDom.find('input').eq(0).prop('checked',true);
		};
		$("#updateMemberForm .indetityTable").append(cloneIdentityDom);
	};


	var imgSource = '';
	//触发选择头像
	$(".yk_addPicture span").click(function(){
		if ( !window.FileReader ) {
			new $.zui.Messager('您的浏览器不支持预览图片上传，请升级您的浏览器', {
			    type: 'danger'
			}).show();
            return;
        };
		$(this).next().click();
	});

	//选中头像
	$(".yk_addPicture input").change(function(e){
		var file = e.target.files || e.dataTransfer.files;
		if( 10*1024*1024 < file[0].size ){
			new $.zui.Messager('请选择不超过10M的图片', {
			    type: 'danger'
			}).show();
	      	return;
	    };
	    imgSource = file[0];//用于提交
	    var reader = new FileReader();
	    reader.readAsDataURL(file[0]);//转换为 base64
	    reader.onload = function (e) {
	      	$("#previewViewImg").attr("src",e.target.result).show();
	    };
	});

	//选择部门
	$(".chooseDepartMent").click(function(){
		$("#myModal-adjustDepartment").modal("show");
		//右侧初始显示已有部门
		$(".yk_check_main").empty();
		for( var i=0;i<$(".chooseDepartMent span").length;i++ ){
			$(".yk_check_main").append('<li class="yk_check_list_item yk_check_list_item_'+$(".chooseDepartMent span").eq(i).attr("chooseid")+'"><i class="icon icon-folder-close"></i><span>'+$(".chooseDepartMent span").eq(i).text()+'</span><i dataid="'+$(".chooseDepartMent span").eq(i).attr("chooseid")+'" class="icon icon-remove-circle"></i></li>');
		};
		i = null;
		getRootDepartNode();
	});

	//调整部门-点击子部门
	$('.yk_selector_main').on("click",'li em',fillSelectorMain);

	//调整部门-选择部门的导航头点击
	$(".yk_selector_navbar").on("click",'.yk_selector_navbar_item.notfirst:not(:last)',fillSelectorMain);
	$(".yk_selector_navbar").on("click",'.yk_selector_navbar_item:not(.notfirst)',getRootDepartNode);

	//调整-选择部门的导航头'返回箭头'效果
	$(".yk_selector_navbar").on("click",'.backbtn',fillSelectorMain);

	//调整-选择(选中)部门
	$(".yk_selector_main").on("click","li",function(e){
		if( $(e.target).hasClass("leftcheck") ){
			if( $(e.target).is(":checked") ){
				$(this).find(".childDepart").addClass("disable");
				$(".yk_check_main").append('<li class="yk_check_list_item yk_check_list_item_'+$(this).attr("dataid")+'"><i class="icon icon-folder-close"></i><span>'+$(this).find("span").text()+'</span><i dataid="'+$(this).attr("dataid")+'" class="icon icon-remove-circle"></i></li>')
			}else{
				 $(this).find(".childDepart").removeClass("disable");
				 $(".yk_check_main").find(".yk_check_list_item_"+$(this).attr("dataid")).remove();
			}
		}else if( $(e.target).hasClass("childDepart") ){
			return;
		}else{
			if( $(this).find("input").is(":checked") ){
				 $(this).find("input").prop("checked",false);
				 $(this).find(".childDepart").removeClass("disable");
				 $(".yk_check_main").find(".yk_check_list_item_"+$(this).attr("dataid")).remove();
			}else{
				$(this).find("input").prop("checked",true);
				$(this).find(".childDepart").addClass("disable");
				$(".yk_check_main").append('<li class="yk_check_list_item yk_check_list_item_'+$(this).attr("dataid")+'"><i class="icon icon-folder-close"></i><span>'+$(this).find("span").text()+'</span><i dataid="'+$(this).attr("dataid")+'" class="icon icon-remove-circle"></i></li>')
			}
		}
	});

	//调整部门-全选
	$(".yk_selector_checkbtn input").click(function(){
		if( $(this).is(":checked") ){
			$(".yk_selector_main li input").prop("checked",true);
			$(".yk_selector_main li .childDepart").addClass("disable");
			for( var i=0;i<$(".yk_selector_main li").length;i++ ){
				if( $(".yk_check_main").find(".yk_check_list_item_"+$(".yk_selector_main li").eq(i).attr("dataid")).length<=0 ){
					$(".yk_check_main").append('<li class="yk_check_list_item yk_check_list_item_'+$(".yk_selector_main li").eq(i).attr("dataid")+'"><i class="icon icon-folder-close"></i><span>'+$(".yk_selector_main li").eq(i).find("span").text()+'</span><i dataid="'+$(".yk_selector_main li").eq(i).attr("dataid")+'" class="icon icon-remove-circle"></i></li>')
				}
			};
			i = null;
		}else{
			$(".yk_selector_main li input").prop("checked",false);
			$(".yk_selector_main li .childDepart").removeClass("disable");
			for( var i=0;i<$(".yk_selector_main li").length;i++ ){
				$(".yk_check_main").find(".yk_check_list_item_"+$(".yk_selector_main li").eq(i).attr("dataid")).remove();
			};
			i = null;
		}
	});

	//调整部门-右侧叉号取消选中
	$(".yk_check_main").on("click",".icon-remove-circle",function(){
		for( var i=0;i<$(".yk_selector_main li").length;i++ ){
			if( $(".yk_selector_main li").eq(i).attr("dataid") == $(this).attr("dataid") ){
				$(".yk_selector_main li").eq(i).find(".leftcheck").prop("checked",false);
				$(".yk_selector_main li").eq(i).find(".childDepart").removeClass("disable");
				break;
			}
		};
		i = null;
		$(this).parents(".yk_check_list_item").remove();

	});

	//确认选择部门
	$(".chooseDepartSure").click(function(){
		if( $(".yk_check_main li").length<=0 ){
			new $.zui.Messager('请至少选择一个部门', {
			    type: 'danger'
			}).show();
			return;
		};
		var checkDepart = '';
		$(".indetityBox.show").remove();
		for( var i=0;i<$(".rightAlreadyCheck .yk_check_list_item").length;i++ ){
			checkDepart += '<span chooseid="'+$(".rightAlreadyCheck .yk_check_list_item").eq(i).find(".icon-remove-circle").attr('dataid')+'">'+$(".rightAlreadyCheck .yk_check_list_item").eq(i).find("span").text()+'</span>'
			appendCloneDom($(".rightAlreadyCheck .yk_check_list_item").eq(i).find("span").text(),i,$(".rightAlreadyCheck .yk_check_list_item").eq(i).find(".icon-remove-circle").attr('dataid'));
		};
		i = null;
		$(".chooseDepartMent").empty().append(checkDepart);
		$("#myModal-adjustDepartment").modal("hide");
	});

	//获取成员信息
	function getMemberNews(){
		$.ajax({
			url:'/user/do_get',
			type:'get',
			data:{
				id:rightMemberId,
				orgId:rightDepartmentId
			},
			success:function(data){
				if( data.success ){
					$(".yk_orgContentTitle .name").text(data.data.name);
					$("#addName").val(data.data.name);
					$("#addMobile").val(data.data.mobile);
					$("#addEmail").val(data.data.email);
					$("#addLoginName").val(data.data.loginName);
					var chooseDepartHtml = '';
					for( var i=0;i<data.data.relativeName.split("、").length-1;i++ ){
						chooseDepartHtml += '<span chooseid="'+data.data.orgIdList[i]+'">'+data.data.relativeName.split("、")[i].split('-')[data.data.relativeName.split("、")[i].split('-').length-1]+'</span>'
					};
					i = null;
					$(".chooseDepartMent").html(chooseDepartHtml);
					// 身份
					for( var i=0;i<data.data.userOrgRelList.length;i++ ){
						appendCloneDom(data.data.userOrgRelList[i].orgName,i,data.data.userOrgRelList[i].orgId,data.data.userOrgRelList[i].userIdentity);
					};
					i = null;
					$("#addJobNumber").val(data.data.jobNumber);
					$("#addPosition").val(data.data.position);
					$("#addTel").val(data.data.tel);
					$("#rank").val(data.data.rank?data.data.rank:'');
					$("#followType").val(data.data.followType == undefined?'':data.data.followType);
					if( data.data.userIdentityDisplayName=='上级' ){
						$("input[name=userIdentity]:last").prop("checked",true);
					}else{
						$("input[name=userIdentity]:first").prop("checked",true);
					}
					if( data.data.relationDingDing){
						$("input[name=relationDingDing]:last").prop("checked",true);
					}else{
						$("input[name=relationDingDing]:first").prop("checked",true);
					}
					if( data.data.headImgUrl ){
						$(".yk_addPicture img").attr("src",data.data.headImgUrl).show()
					};
				}else{
					new $.zui.Messager('获取成员信息失败:'+data.msg, {
					    type: 'danger'
					 }).show();
				}
			},
			error:function(status){
				new $.zui.Messager('获取成员信息错误:'+status, {
				    type: 'danger'
				 }).show();
			}
		})
	};
	getMemberNews();

	//'身份'参数名称鼠标移入显示全部文字
	//$("#updateMemberForm").on("mouseover",".userIdentitylabel",function(){$(this).parent().find('.userIdentityTip').remove().end().append('<span class="userIdentityTip">'+$(this).text()+'</span>')});
	//$("#updateMemberForm").on("mouseleave",".userIdentitylabel",function(){$(this).parent().find('.userIdentityTip').remove()});

	//保存
	function updateOrgMember(){
		$("#updateMemberForm").validate({
			 promptPosition : "bottomLeft",
			 submitHandler : function(form) {
				//验证登录名是否重复
				 var loginNameFlag = false;
				  $.ajax({
					 url:'/user/validatorLoginName',
					 type:'get',
					 async:false,
					 data:{
						 'userId':rightMemberId,
						 'loginName':$("#addLoginName").val()
					 },
					 success:function(data){
						 if( data.success ){
							 if( !data.data ){
								 new $.zui.Messager('该登录名已存在,请修改后重新保存', {
								    type: 'danger'
								 }).show();
								 loginNameFlag = false;
							 }else{
								 loginNameFlag = true;
							 }
						 }else{
							 new $.zui.Messager('验证登录名是否重复时请求失败:'+ data.msg, {
							    type: 'danger'
							 }).show();
							 loginNameFlag = false;
						 }
					 },
					 error:function(status){
						 new $.zui.Messager('验证登录名是否重复时发生错误:'+status, {
						    type: 'danger'
						 }).show();
						 loginNameFlag = false;
					 }
				 });
				if( !loginNameFlag ){
					return;
				};

				 var addMemberNewPostData = new FormData();
				addMemberNewPostData.append("id",rightMemberId);
				addMemberNewPostData.append("name",$("#addName").val());
				addMemberNewPostData.append("mobile",$("#addMobile").val());
				addMemberNewPostData.append("email",$("#addEmail").val());
				addMemberNewPostData.append("loginName",$("#addLoginName").val());
				addMemberNewPostData.append("password",$("#addPassword").val());
				// addMemberNewPostData.append("jobNumber",$("#addJobNumber").val());
				addMemberNewPostData.append("position",$("#addPosition").val());
				// addMemberNewPostData.append("tel",$("#addTel").val());
				//  addMemberNewPostData.append("rank",$("#rank").val());
				//  addMemberNewPostData.append("followType",$("#followType").val());
				//addMemberNewPostData.append("userIdentity",$("[name=userIdentity]:checked").val());
				// addMemberNewPostData.append("relationDingDing",$("[name=relationDingDing]:checked").val());
				for (var i = 0; i < $(".chooseDepartMent span").length; i++) {
					addMemberNewPostData.append("orgIdList["+i+"]",$(".chooseDepartMent span").eq(i).attr("chooseid"))
				};
				i = null;
				// 部门身份
				for( var i=0;i<$(".indetityBox.show").length;i++ ){
					addMemberNewPostData.append('userOrgRelList['+i+'].orgId',$(".indetityBox.show").eq(i).find('.userIdentitylabel').attr('orgid'));
					addMemberNewPostData.append('userOrgRelList['+i+'].userIdentity',$(".indetityBox.show").eq(i).find('input:checked').val());
				};
				i = null;

				if( imgSource!='' ){
					addMemberNewPostData.append("file",imgSource);
				};
				$(".yk_addBtns .save").addClass('loadingCircle');
				$.ajax({
					url:'/user/do_update',
					type:'post',
					processData:false,
					contentType:false,
					data:addMemberNewPostData,
					success:function(data){
						if( data.success ){
							$(".yk_addBtns .save").removeClass('loadingCircle');
							new $.zui.Messager('修改成员成功', {
							    type: 'success'
							}).show();
							$(".yk_orgContent").load('/org/departmentContent',function(){
								backTop('.yk_orgContent');
								$(".yk_orgContentTitle span").text(rightDepartmentTitle);
								if( rightDepartmentId=='1' ){//是'长安银科'
									$(".yk_updateDepartment").remove();
								}
							});
							refreshDepartTree(rightDepartmentId)
						}else{
							$(".yk_addBtns .save").removeClass('loadingCircle');
							new $.zui.Messager('修改成员失败:'+data.msg, {
							    type: 'danger'
							 }).show();
						}
					},
					error:function(){
						$(".yk_addBtns .save").removeClass('loadingCircle');
						new $.zui.Messager('修改成员发生错误:'+status, {
						    type: 'danger'
						 }).show();
					}
				})

			},
			rules : {
				"name":{
					required:true,
					maxlength:8
				},
				"mobile":{
					required:true,
					mobileValid:true
				},
				"email":{
					required:true,
					maxlength:50,
					email:true
				},
				"loginName":{
					required:true,
					maxlength:30,
					loginNameValid:true
				},
				'jobNumber':{
					maxlength:30,
					jobNumberValid:true
				},
				"tel":{
					maxlength:10,
					telValid:true
				},
				"position":{
					maxlength:30
				},
				"followType":{
					required:true
				},
				"rank":{
					required:true
				}

			},
			messages : {
				"name":{
					required:"请输入姓名",
					maxlength:'姓名最多可输入8个字符'
				},
				"mobile":{
					required:"请输入手机号码"
				},
				"email":{
					required:"请输入企业邮箱",
					maxlength:"邮箱最多可输入50个字符"
				},
				"loginName":{
					required:"请输入登录名",
					maxlength:'登录名最多可输入30个字符'
				},
				"password":{
					required:"请输入登录密码"
				},
				'jobNumber':{
					maxlength:'工号最多可输入30个字符'
				},
				'tel':{
					maxlength:'分机号最多可输入10个字符'
				},
				"position":{
					maxlength:'职位最多可输入30个字符'
				},
				"followType":{
					required:"请选择跟投类别"
				},
				"rank":{
					required:"请选择职级"
				}
			}
		});
	};
	$(".yk_addBtns .save").click(updateOrgMember);

	//取消
	$(".btn-cancel").unbind("click").click(function(){
		$(".yk_orgContent").load('/org/departmentContent',function(){
			backTop('.yk_orgContent');
			$(".yk_orgContentTitle span").text(rightDepartmentTitle);
			if( rightDepartmentId=='1' ){//是'长安银科'
				$(".yk_updateDepartment").remove();
			}
		});
		return false;
	});
})
